// AllVisible.cpp : Definiert die exportierten Funktionen fr die DLL-Anwendung.
/**********************************************************************/
#include "std.h"
#include "megatyp.h"
#include "megacad.h"
/**********************************************************************/

/* 
// Diese Funktion wird von EntityLoop aufgerufen 
// setzt die Visibility des bergebenen Elements auf sichtbar
*/
short SetVisible(void* pArg)
{
    t_entity* pEnt;

    pEnt = (t_entity*) pArg;

	SetVisibility( &pEnt->id, 1, IV_THESE_VISI); 

    return(CONTINUE_LOOP);
}


/*
// Hauptfunktion, wird von MegaCAD aufgerufen
// Durchluft je eine Schleife fr alle Layer- und Gruppenitems,
// setzt dabei die durchlaufenen Items auf sichtbar.
// Ruft EntityLoop auf, 
// EntityLoop durchluft eine Schleife fr alle Elemente der Zeichnung,
// und ruft fr jedes Element die Funktion SetVisible auf.
*/
short MegaMain(	char *filename, char *args )
{
    t_entity ent;
    ulong    filter;
	ushort	 err;

    h_LGList hLListHandle;
	h_LGList hGListHandle;
    h_LGItem hLListItem;
    h_LGItem hGListItem;
    
    t_LayGrpDta  ItemData; 

    hLListHandle = LG_CreateList(LGL_LAYER, &err);  
	hGListHandle = LG_CreateList(LGL_GROUP, &err); 

	hLListItem = LGITEM_ROOT;
	hGListItem = LGITEM_ROOT;
	
	// Alle Layer durchlaufen und einschalten
    while (hLListItem = LG_ItemOp(hLListHandle, hLListItem, NULL, &ItemData, LGOP_LINEARNEXT, &err)) 
    {
		ItemData.flags |= LGF_ON;
		LG_ItemOp(hLListHandle, hLListItem, 0, &ItemData, LGOP_SETDATA, &err);
    } 
	
	// Alle Gruppen durchlaufen und einschalten
    while (hGListItem = LG_ItemOp(hGListHandle, hGListItem, NULL, &ItemData, LGOP_LINEARNEXT, &err)) 
    {
		ItemData.flags |= LGF_ON;
		LG_ItemOp(hGListHandle, hGListItem, 0, &ItemData, LGOP_SETDATA, &err);
    } 
	
	// die geaenderten Listen an MegaCAD uebergeben
    LG_Replace(hLListHandle, hGListHandle, 0);
    
    // Listen loeschen:
    LG_ItemOp(hLListHandle, LGITEM_ROOT, 0, &ItemData, LGOP_DELETE, &err);
	LG_ItemOp(hGListHandle, LGITEM_ROOT, 0, &ItemData, LGOP_DELETE, &err);

	// Selektionskriterium -> alle Elemente erlaubt
    filter = 0xffffffff;
	// Schleife ber alle Elemente
    EntityLoop(filter, filter, SetVisible, &ent, NULL, 0, NULL);
 
	return 0;
}


